class RbacRole(object):
    check_object_level_access = False

    @classmethod
    def rbac_hash(cls):
        return cls.get_name()

    @classmethod
    def __str__(cls):
        return cls.get_name()

    @classmethod
    def get_name(cls):
        """
        Returns role name

        :return: str
        """
        raise NotImplementedError('Method "get_name" must be implemented in any derived class')


class RbacRoleNoRole(RbacRole):
    @classmethod
    def get_name(cls):
        return 'anonymous'


class RbacRoleAnyRole(RbacRole):
    @classmethod
    def get_name(cls):
        return 'any'
