def get_db(db_label='default'):
    return globals()['_databases'][db_label]


# noinspection PyUnresolvedReferences
from sqlalchemy import Column
from sqlalchemy.ext.declarative import declarative_base as _declarative_base
from .. logger import log
from . db_class import DB as _DB
from . base_model_class import BaseModelClass as _BaseModelClass

_databases = dict()
BaseModel = _declarative_base(cls=_BaseModelClass)


def initialize_db(conn_string, declarative_base=BaseModel, db_label='default'):
    log.info('DB [{}]: Initializing DB, label {}'.format(db_label, db_label))
    globals()['_databases'][db_label] = _DB(declarative_base, db_label)
    globals()['_databases'][db_label].create_engine(conn_string)
    globals()['_databases'][db_label].create_session()
    return get_db(db_label)
