# noinspection PyUnresolvedReferences
from sqlalchemy import or_, and_, text as original_text, UniqueConstraint, PrimaryKeyConstraint
# noinspection PyUnresolvedReferences
from sqlalchemy.sql import func, schema
# noinspection PyUnresolvedReferences
from sqlalchemy.orm import relationship
from falcon_rest.conf import settings
import uuid
import os


# noinspection PyUnusedLocal
def get_empty_text_func(txt):
    return ''


if 'postgresql' not in settings.DB_CONN_STRING or os.environ.get('FAKE_DB_TEXT_FUNCTION'):
    text = get_empty_text_func
else:  # pragma: no cover
    text = original_text


def get_foreign_keys(model_obj):
    referencing_foreign_keys = list()

    for constraint in model_obj.__table__.constraints:
        if isinstance(constraint, schema.ForeignKeyConstraint):
            for fk in constraint.elements:
                referencing_foreign_keys.append(fk)

    return referencing_foreign_keys


def generate_uuid_str():
    return lambda: str(uuid.uuid4())
