class Signal(object):
    def __init__(self):
        self._receivers = {}

    @staticmethod
    def get_receiver_hash(receiver):
        return str(receiver).rsplit(' ', 1)[1][:-1]

    def connect(self, receiver, receiver_hash=None, send_sender=True, send_keys=None):
        self._receivers[(receiver_hash or self.get_receiver_hash(receiver))] = receiver, send_sender, send_keys

    def disconnect(self, receiver, receiver_hash):  # pragma: no cover
        del self._receivers[(receiver_hash or self.get_receiver_hash(receiver))]

    def send(self, sender, **kwargs):
        for receiver, send_sender, send_keys in self._receivers.values():
            if send_keys is None:  # pragma: no cover
                needed_kwargs = kwargs
            elif not send_keys:  # pragma: no cover
                needed_kwargs = {}
            else:
                needed_kwargs = {}
                for key in send_keys:
                    needed_kwargs[key] = kwargs[key]

            receiver(sender, **needed_kwargs) if send_sender else receiver(**needed_kwargs)
