from .. conf import settings
from . swagger import Swagger
from . specify import get_spec
from . path_helpers import path_tagging, deprecate_path


def init(routes, schemes_paths_list=[], schemes=[]):
    swagger_obj = Swagger(
        settings.API_TITLE, settings.API_HOST, settings.API_BASE_PATH, settings.VERSION
    )

    swagger_obj.register_path_helper(path_helpers.path_tagging)
    swagger_obj.register_path_helper(path_helpers.deprecate_path)

    swagger_obj.add_common_schemes()
    for scheme in schemes:
        swagger_obj.add_definition(scheme)

    if settings.AUTH_MODULE:
        schemes_paths_list.append(settings.AUTH_MODULE)

    for schemes_path in schemes_paths_list:
        swagger_obj.add_definitions_from_submodules(schemes_path)

    swagger_obj.add_paths(routes)
    return swagger_obj
