from . api_authorized_test_case import ApiAuthorizedTestCase


class BaseCreateTestCase(ApiAuthorizedTestCase):
    model_class = None
    scheme_class = None
    endpoint = None

    create_endpoint = None

    no_validation = False

    __test__ = False

    # noinspection PyPep8Naming
    @classmethod
    def setUpClass(cls):
        if cls.endpoint and not cls.create_endpoint:
            cls.create_endpoint = '{}/create'.format(cls.endpoint)

    # noinspection PyMethodMayBeStatic
    def get_data_for_validation_error(self):
        return {}

    def create_object_through_post(self):
        obj = self.get_random_object()
        return obj, self.post(self.create_endpoint, self.scheme_class().dump(obj).data)

    def test_create__validation_error(self):
        if not self.no_validation:
            result = self.post(self.create_endpoint, self.get_data_for_validation_error())
            self.assertEqual(*self.get_assert_validation_error___status(result))
            self.assertDictEqual(*self.get_assert_validation_error___body(result))

    def test_create__success(self):
        _, result = self.create_object_through_post()
        self.assertEqual(*self.get_assert_success___status(result))
        self.assertDictEqual(*self.get_assert_object_created___body(result))

    def test_create__already_exists_error(self):
        if not self.has_unique_field:
            return
        obj, _ = self.create_object_through_post()
        result = self.post(self.create_endpoint, self.scheme_class().dump(obj).data)
        self.assertEqual(*self.get_assert_operation_error___status(result))
        self.assertDictEqual(*self.get_assert_operation_error___body(result))

    def get_assert_object_created___body(self, result):
        return self.get_assert___body(result, self.scheme_class.get_object_created_response().scheme)
