from . create_object import BaseCreateObject


class BaseResourceDeleteTestCase(BaseCreateObject):
    has_update_by = True
    has_unique_field = True

    endpoint = None
    resource_endpoint = None
    resource_endpoint_not_found = None

    __test__ = False

    # noinspection PyPep8Naming
    @classmethod
    def setUpClass(cls):
        if not cls.resource_endpoint:
            cls.resource_endpoint = '{}/1'.format(cls.endpoint)

        if not cls.resource_endpoint_not_found:
            cls.resource_endpoint_not_found = '{}/not_existent_id'.format(cls.endpoint)

    def test_resource__delete(self):
        self.create_object()
        result = self.delete(self.resource_endpoint)
        self.assertEqual(*self.get_assert_success___status(result))
        self.assertDictEqual(*self.get_assert_just_ok___body(result))

        result = self.delete(self.resource_endpoint)
        self.assertEqual(*self.get_assert_not_found_error___status(result))
        self.assertDictEqual(*self.get_assert_not_found_error___body(result))
