from falcon_rest import schemes
from . create_object import BaseCreateObject


class BaseResourceInfoTestCase(BaseCreateObject):
    endpoint = None
    resource_endpoint = None
    resource_endpoint_not_found = None

    __test__ = False

    # noinspection PyPep8Naming
    @classmethod
    def setUpClass(cls):

        if not cls.resource_endpoint:
            cls.resource_endpoint = '{}/1'.format(cls.endpoint)

        if not cls.resource_endpoint_not_found:
            cls.resource_endpoint_not_found = '{}/not_existent_id'.format(cls.endpoint)

    def test_resource__not_found_on_get_error(self):
        result = self.get(self.resource_endpoint_not_found)
        self.assertEqual(*self.get_assert_not_found_error___status(result))
        self.assertDictEqual(*self.get_assert_not_found_error___body(result))

    def test_resource__get(self):
        self.create_object()
        result = self.get(self.resource_endpoint)
        self.assertEqual(*self.get_assert_success___status(result))
        self.assertDictEqual(*self.get_assert___body(result, schemes.ObjectScheme))
