from . create_object import BaseCreateObject
from . base_create_test_case import BaseCreateTestCase
from . base_resource_info_test_case import BaseResourceInfoTestCase
from . base_resource_modify_test_case import BaseResourceModifyTestCase
from . base_resource_delete_test_case import BaseResourceDeleteTestCase
from . base_list_test_case import BaseListTestCase


def set_up_class(cls):
    if cls.endpoint:
        cls.create_endpoint = '{}/create'.format(cls.endpoint)
        cls.list_endpoint = '{}/list'.format(cls.endpoint)

    if not cls.resource_endpoint:
        cls.resource_endpoint = '{}/1'.format(cls.endpoint)

    if not cls.resource_endpoint_not_found:
        cls.resource_endpoint_not_found = '{}/not_existent_id'.format(cls.endpoint)

    if cls.endpoint and not cls.list_endpoint:
        cls.list_endpoint = '{}/list'.format(cls.endpoint)


# noinspection PyAbstractClass
class BaseResourceTestCase(
    BaseCreateTestCase, BaseResourceInfoTestCase, BaseResourceModifyTestCase,
    BaseResourceDeleteTestCase, BaseListTestCase
):
    __test__ = False

    # noinspection PyPep8Naming
    @classmethod
    def setUpClass(cls):
        set_up_class(cls)


class BaseResourceNoWriteTestCase(BaseResourceInfoTestCase, BaseListTestCase):
    __test__ = False

    # noinspection PyPep8Naming
    @classmethod
    def setUpClass(cls):
        set_up_class(cls)


# noinspection PyAbstractClass
class BaseResourceNoReadTestCase(
    BaseCreateTestCase, BaseResourceModifyTestCase, BaseResourceDeleteTestCase, BaseListTestCase
):
    __test__ = False

    # noinspection PyPep8Naming
    @classmethod
    def setUpClass(cls):
        set_up_class(cls)


# noinspection PyAbstractClass
class BaseResourceListOnlyTestCase(BaseCreateObject, BaseListTestCase):
    scheme_class = None

    __test__ = False

    # noinspection PyPep8Naming
    @classmethod
    def setUpClass(cls):
        super(BaseResourceListOnlyTestCase, cls).setUpClass()
