from . base_resource_test_case import (
    BaseResourceTestCase, BaseResourceListOnlyTestCase, BaseResourceNoWriteTestCase, BaseResourceNoReadTestCase
)


def create_base_resource_test_case(
    name, model_class, scheme_class, endpoint, modify_object, has_update_by=False, has_unique_field=False,
    no_validation=False, random_obj_dict={}, resource_endpoint=None
):
    return type(
        name, (BaseResourceTestCase, ),
        dict(
            model_class=model_class, scheme_class=scheme_class, endpoint=endpoint, modify_object=modify_object,
            has_update_by=has_update_by, has_unique_field=has_unique_field, no_validation=no_validation,
            random_obj_dict=random_obj_dict, resource_endpoint=resource_endpoint, __test__=True
        )
    )


def create_base_resource_no_write_test_case(
    name, scheme_class, endpoint, resource_endpoint=None, resource_endpoint_not_found=None, list_endpoint=None,
    random_obj_dict={}
):
    return type(
        name, (BaseResourceNoWriteTestCase, ),
        dict(
            endpoint=endpoint, scheme_class=scheme_class, resource_endpoint=resource_endpoint,
            resource_endpoint_not_found=resource_endpoint_not_found, list_endpoint=list_endpoint,
            random_obj_dict=random_obj_dict, __test__=True
        )
    )


def create_base_resource_list_test_case(name, scheme_class, list_endpoint, random_obj_dict={}):
    return type(
        name, (BaseResourceListOnlyTestCase, ),
        dict(scheme_class=scheme_class, list_endpoint=list_endpoint, random_obj_dict=random_obj_dict, __test__=True)
    )


def create_base_resource_no_read_test_case(
        name, model_class, scheme_class, endpoint, modify_object,
        has_update_by=False, has_unique_field=False, no_validation=False
):
    return type(
        name, (BaseResourceNoReadTestCase, ),
        dict(
            model_class=model_class, scheme_class=scheme_class, endpoint=endpoint, modify_object=modify_object,
            has_update_by=has_update_by, has_unique_field=has_unique_field, no_validation=no_validation, __test__=True
        )
    )
